/*****************************************************************************
* Copyright (c) 2005 Digi International Inc., All Rights Reserved
* 
* This software contains proprietary and confidential information of Digi
* International Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Digi International
* Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
* prohibited.
* 
* Restricted Rights Legend
*
* Use, duplication, or disclosure by the Government is subject to
* restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
* Technical Data and Computer Software clause at DFARS 252.227-7031 or
* subparagraphs (c)(1) and (2) of the Commercial Computer Software -
* Restricted Rights at 48 CFR 52.227-19, as applicable.
*
* Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
*
*****************************************************************************/

#ifndef magicRestartFlags_h

#define magicRestartFlags_h    

#include "asmmacros.h"

/*
 * This value is loaded into R10 and R11 to indicate R12 contains
 * special restart flags set by either the debugger or blExecuteImage().
 */
CONSTANT(NA_RESTART_SIGNATURE, 0xCAFEBABE)

/*
 * This value is loaded into R12 to indicate that a software restart
 * is occurring.  Setting this flags tells the initialization code to
 * skip over certain steps, such as initialization the memory controller,
 * that we do not want to a software restart to do.
 */
CONSTANT(SOFTWARE_RESTART_FLAG, 0x2)

/*
 * This value is loaded into R12 to indicate that we are running under a 
 * debugger.  Setting this flags tells the initialization code to
 * skip over certain steps, such as initialization the memory controller,
 * that we do not want to a software restart to do.
 */
CONSTANT(DEBUGGER_FLAG, 0x1)


CONSTANT(FLAGS_MASK, 0x3)


#endif
